<?php

namespace Drupal\mappi_lane\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FormatterBase;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'mappi_embed' formatter.
 *
 * @FieldFormatter(
 *   id = "mappi_embed_formatter",
 *   label = @Translation("Mappi embed formatter"),
 *   field_types = {
 *     "mappi"
 *   }
 * )
 */
class MappiEmbedFormatter extends FormatterBase {
  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode)
  {
    $elements = array();
    foreach($items as $delta => $item) {
      $elements[$delta] = array(
        '#theme' => 'mappi_embed',
        '#map_url' => $item->value,
      );
    }

    return $elements;
  }
}
