<?php

namespace Drupal\mappi_lane\Plugin\Field\FieldWidget;

use Drupal\Core\Field\FieldItemListInterface;
use Drupal\Core\Field\WidgetBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'viewfield' widget.
 *
 * @FieldWidget (
 *    id = "mappi_default_widget",
 *    label = @Translation("Mappi default"),
 *    field_types = {
 *      "mappi"
 *   }
 * )
 */
class MappiDefaultWidget extends WidgetBase {

  /**
   * {@inheritdoc}
   */
  public function formElement(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state)
  {
    $base_URL = $this->getFieldSetting('customer_base_url');
    $maps = $this->getMaps($base_URL);


    $element['value'] = array(
      '#title' => $this->t('Mappi kaarten'),
      '#type' => 'select',
      '#options' => $maps,
      '#default_value' => $items[$delta]->value ?? NULL,
    );

    return $element;
  }

  function getMaps($base_url) {
    $map_array = array();
    // TODO: Proper error handling
    set_error_handler(function() {
      var_dump('The base URL does not exist or does not return results');
    });

    $response = json_decode(file_get_contents('https://'.$base_url.'/api/maps.json'), true)['data'];

    foreach ($response as $map) {
      $map_array[$map['url']] = $map['title'].' ('.$map['url'].')';
    }
    restore_error_handler();

    return $map_array;
  }
}
